
import com.hazelcast.client.HazelcastClient;
import com.hazelcast.config.Config;
import com.hazelcast.config.DataConnectionConfig;
import com.hazelcast.config.MapConfig;
import com.hazelcast.config.MapStoreConfig;
import com.hazelcast.core.Hazelcast;
import com.hazelcast.core.HazelcastInstance;
import com.hazelcast.map.IMap;
import com.hazelcast.mapstore.GenericMapLoader;
import com.hazelcast.mapstore.GenericMapStore;
import com.hazelcast.query.Predicate;
import com.hazelcast.query.Predicates;
import java.util.concurrent.TimeUnit;


public final class Client {
    public static String MYSQL_HOST = "192.168.0.174";
     public static String MYSQL_DB="hz_db";
     
    private Client() {
    }

    public static void main(String[] args) throws Exception {
    Config config = new Config();
    config.getJetConfig().setEnabled(true);
    config.getUserCodeDeploymentConfig().setEnabled(true);    
    //configure JDBC data connection
    config.addDataConnectionConfig(new DataConnectionConfig(MYSQL_DB)
      .setType("JDBC")
      .setProperty("jdbcUrl", "jdbc:mysql://" + MYSQL_HOST + ":3306")
      .setProperty("user", "hz")
      .setProperty("password", "password")
      .setShared(true));

    HazelcastInstance hz = Hazelcast.newHazelcastInstance(config);
    
    //configure map to be stored in DB
    MapConfig mapConfig = new MapConfig("dbMap");
    MapStoreConfig mapStoreConfig = new MapStoreConfig();
    mapStoreConfig.setClassName(GenericMapStore.class.getName());
    mapStoreConfig.setProperty("data-connection-ref", MYSQL_DB);
    
    mapStoreConfig.setProperty("external-name","times");
    mapStoreConfig.setProperty("id-column", "mid");
    mapStoreConfig.setProperty("load-all-keys","true");
    
    mapConfig.setMapStoreConfig(mapStoreConfig);
    hz.getConfig().addMapConfig(mapConfig);    
    
    System.out.println("Hazelcast Member instance is running!");


    IMap<String, String> map = hz.getMap("dbMap");
    
//    String q = ""
//      + "CREATE MAPPING times " 
//      + "TYPE JDBC "
//      + "OPTIONS ("
//      + "'externalDataStoreRef'='"+MYSQL_DB+"'" 
//      +")";
//      System.out.println("SQL: "+q);
//      
//    Predicate sqlQuery = Predicates.sql(q);
//    
//    map.values(sqlQuery);
    

        for( int i = 0 ; i < 1000 ; i++){
            System.out.println("Adding record "+i);
            String key = "" + System.nanoTime();
            String value = String.valueOf(i);
            DbRecord r = new DbRecord(key,value);

            map.put(key,value);
            //sleep 2s
            TimeUnit.SECONDS.sleep(2);
        }
        System.out.println("Exiting Client!");

        HazelcastClient.shutdownAll();
    }
}
