import com.hazelcast.config.Config;
import com.hazelcast.config.DataConnectionConfig;
import com.hazelcast.config.MapConfig;
import com.hazelcast.config.MapStoreConfig;
import com.hazelcast.core.EntryEvent;
import com.hazelcast.core.Hazelcast;
import com.hazelcast.core.HazelcastInstance;
import com.hazelcast.map.IMap;
import com.hazelcast.map.listener.EntryAddedListener;
import com.hazelcast.map.listener.EntryRemovedListener;
import com.hazelcast.map.listener.EntryUpdatedListener;
import com.hazelcast.mapstore.GenericMapStore;

public class Member {
  public static String MYSQL_HOST = "192.168.0.174";

  public static void main(String[] args) throws Exception {
    Config config = new Config();
    config.getUserCodeDeploymentConfig().setEnabled(true);
    //configure JDBC data connection
    config.addDataConnectionConfig(new DataConnectionConfig("my-mysql-database")
      .setType("JDBC")
      .setProperty("jdbcUrl", "jdbc:mysql://" + MYSQL_HOST + ":3306")
      .setProperty("user", "root")
      .setProperty("password", "Qwerty123").
      setShared(true));



    HazelcastInstance hz = Hazelcast.newHazelcastInstance(config);
    
    //configure map to be stored in DB
    MapConfig mapConfig = new MapConfig("dbMap");
    MapStoreConfig mapStoreConfig = new MapStoreConfig();
    mapStoreConfig.setClassName(GenericMapStore.class.getName());
    mapStoreConfig.setProperty("data-connection-ref", "hz_db");
    mapConfig.setMapStoreConfig(mapStoreConfig);
    hz.getConfig().addMapConfig(mapConfig);    
    
    System.out.println("Hazelcast Member instance is running!");

    //get map and watch it
    IMap<String, String> map = hz.getMap("dbMap");
    map.addEntryListener(new MyEntryListener(), true);
    System.out.println("EntryListener registered");
  }

    private static class MyEntryListener implements EntryAddedListener<String, String>,
            EntryRemovedListener<String, String>, EntryUpdatedListener<String, String> {
        @Override
        public void entryAdded(EntryEvent<String, String> event) {
            System.out.println("entryAdded: " + event);
        }

        @Override
        public void entryRemoved(EntryEvent<String, String> event) {
            System.out.println("entryRemoved: " + event);
        }

        @Override
        public void entryUpdated(EntryEvent<String, String> event) {
            System.out.println("entryUpdated: " + event);
        }
    }
}
