
import com.hazelcast.client.HazelcastClient;
import com.hazelcast.config.Config;
import com.hazelcast.config.DataConnectionConfig;
import com.hazelcast.config.MapConfig;
import com.hazelcast.config.MapStoreConfig;
import com.hazelcast.core.Hazelcast;
import com.hazelcast.core.HazelcastInstance;
import com.hazelcast.map.IMap;
import com.hazelcast.mapstore.GenericMapLoader;
import com.hazelcast.mapstore.GenericMapStore;
import com.hazelcast.query.Predicate;
import com.hazelcast.query.Predicates;
import java.util.UUID;
import java.util.concurrent.TimeUnit;


public final class Client {

     
    private Client() {
    }

    public static void main(String[] args) throws Exception {
    Config config = new Config();


    HazelcastInstance hz = Hazelcast.newHazelcastInstance(config);
    
    //configure map to be stored in DB
    MapConfig mapConfig = new MapConfig("dbMap");
    
    MapStoreConfig mapStoreConfig = new MapStoreConfig();
    mapStoreConfig.setClassName(PersonMapStore.class.getName());
    
    mapConfig.setMapStoreConfig(mapStoreConfig);
    hz.getConfig().addMapConfig(mapConfig);    
    
    System.out.println("Hazelcast Member instance is running!");


    IMap<String, Person> map = hz.getMap("dbMap");
    

        for( int i = 0 ; i < 1000 ; i++){
            System.out.println("Adding record "+i);
            String key = ""+ System.nanoTime() + UUID.randomUUID().toString() ;
            String value = "Name number " + String.valueOf(i);
            Person r = new Person(key,value);

            map.put(key, r);
            //sleep 2s
            TimeUnit.SECONDS.sleep(2);
        }
        System.out.println("Exiting Client!");

        HazelcastClient.shutdownAll();
    }
}
